
// Tuesday night 7-9pm

// minor
//[ 0.0, 2, 3, 5, 7, 8, 10, 12 ] @=> float notes[];
// blues
//[ 0.0, 3, 5, 6, 7, 10, 12 ] @=> float notes[];
// blues 2
[ 0.0, 2, 3, 5, 6, 9, 10, 12 ] @=> float notes[];
    

class Slewer
{
    0 => float mTarget;
    0 => float mValue;
    0 => float mSlew;
    
    fun float rate(float s) { s => mSlew; return mSlew; }
    fun float slew() { (mTarget-mValue)*mSlew + mValue => mValue; return mValue; }
    fun float value() { return mValue; }
    fun float target(float t) { t => mTarget; return mTarget; }
    fun void reset() { mTarget => mValue; }
}

class Blob
{
    int centerX, centerY;
    float area, length;
    int x, y, width, height;
}


class Sounder
{
    fun UGen @ output() { return null; }
    fun void set(Blob b) { }
    fun void unset() { }
}


class NoiseSounder extends Sounder
{
    BandedWG bwg => Gain amp => SawOsc mod => SqrOsc osc => LPF filter => Gain amp2 => Gain feedback => Gain master;
    feedback => DelayA feedbackDelay => feedback;
    Step s => OnePole op => amp2;
    
    0.85 => feedbackDelay.gain;
    1::second => feedbackDelay.max;
    100::ms => feedbackDelay.delay;
    
    0 => s.next;
    0.9995 => op.pole;
    3 => amp2.op;
    
    2 => osc.sync;
    72 => Std.mtof => osc.freq;
    
    2 => mod.sync;
    osc.freq() /4 => mod.freq;
    1000 => mod.gain;
    
    3 => bwg.preset;
    osc.freq() /32 => bwg.freq;
    0.5 => bwg.bowMotion;
    1 => bwg.bowRate;
    //1 => bwg.startBowing;
    
    50 => amp.gain;
    
    osc.freq() * 5 => filter.freq;
    0.5 => filter.Q;
    
    1 => bwg.noteOn;
    
    SinOsc lfo => blackhole;
    1.0/(4) => lfo.freq;
    SinOsc lfo2 => blackhole;
    1.0/(10) => lfo2.freq;
    
    Slewer fbGain;
    0.01 => fbGain.rate;
    0.9 => fbGain.target;
    fbGain.reset();
    
    spork ~ mmod();
    
    fun void mmod()
    {
        while(true)
        {
            (osc.freq() * (6 + 3 * lfo.last())) => filter.freq;
            //0.9+lfo2.last()*0.09 => feedbackDelay.gain;
            fbGain.slew() => feedbackDelay.gain;
            
            10::ms => now;
        }
    }
    
    fun void setFreq(float f)
    {
        f => osc.freq;
        osc.freq() /4 => mod.freq;
        osc.freq() /32 => bwg.freq;
        (osc.freq() * (6 + 3 * lfo.last())) => filter.freq;
    }
    
    fun UGen @ output() { return master; }
    
    fun void set(Blob b)
    {
        55 + notes[((b.x * b.y) / 4000) % notes.cap()] => setNote;
        Math.min(b.area/40000.0, 2) => s.next;
        0.85 + 0.09 * Math.pow((Math.min(b.width/100.0,1)), 0.25) => fbGain.target;
    }
    
    fun void unset()
    {
        0 => s.next;
    }
    
    fun void setNote(float n)
    {
        n => Std.mtof => setFreq;
    }
}


class VoiceSounder extends Sounder
{
    class FMVoice
    {
        SinOsc f1m => SinOsc f1c => Gain mix;
        SinOsc f2m => SinOsc f2c => mix;
        SinOsc f3m => SinOsc f3c => mix;            
        
        2 => f1c.op => f2c.op => f3c.op;
        
        48 => Std.mtof => f1m.freq => f2m.freq => f3m.freq;
        1500 => f1m.gain => f2m.gain => f3m.gain;
        
        // the four-mants
        [ [ 740.0, 1108.0, 2489.0 ], // ah
        [ 530.0, 1864.0, 2637.0 ], // e
        [ 400.0,  800.0, 3250.0 ], // oo
        [ 431.0, 2434.0, 2913.0 ]  // i
        ] @=> float formants[][];
        
        
        formants[0][0] => f1c.freq;
        formants[0][1] => f2c.freq;
        formants[0][2] => f3c.freq;
        
        0.1 => mix.gain;
        
        fun UGen @ output() { return mix; }
        
        fun float freq(float f)
        {
            f => f1m.freq => f2m.freq => f3m.freq;
            return f;
        }
        
        fun float modGain(float mg)
        {
            mg => f1m.gain => f2m.gain => f3m.gain;
            return mg;
        }
    }
    
    Gain mix => Gain amp => Gain feedback => Gain master;
    feedback => DelayA feedbackDelay => feedback;
    Step s => OnePole op => amp;

    0.7 => feedbackDelay.gain;
    1::second => feedbackDelay.max;
    100::ms => feedbackDelay.delay;
    
    0 => s.next;
    0.9995 => op.pole;
    3 => amp.op;
    
    FMVoice f[5];
    
    for(0 => int i; i < f.cap(); i++)
    {
        f[i].output() => mix;
        48 + (i-f.cap()/2)*0.01 => Std.mtof => f[i].freq;
        1500 + (i-f.cap()/2)*100 => f[i].modGain;
    }
    
    SinOsc lfo2 => blackhole;
    1.0/(10) => lfo2.freq;
    
    Slewer fbGain;
    0.01 => fbGain.rate;
    0.9 => fbGain.target;
    fbGain.reset();
    
    spork ~ mod();
    //spork ~ { while(true) { (100+lfo3.last()*2)::ms => feedbackDelay.delay; 100::samp => now; } };
    
    fun float setNote(float n)
    {
        for(0 => int i; i < f.cap(); i++)
        {
            n + (i-f.cap()/2)*0.004 => Std.mtof => f[i].freq;
        }
        
        return n;
    }
    
    fun void mod()
    {
        while(true)
        {
            fbGain.slew() => feedbackDelay.gain;
            10::ms => now;
        }
    }
    
    fun UGen @ output() { return master; }
    
    fun void set(Blob b)
    {
        62 + notes[((b.x * b.y) / 4000) % notes.cap()] => setNote;
        Math.min(b.area/40000.0, 2) => s.next;
        0.85 + 0.09 * Math.pow((Math.min(b.width/100.0,1)), 0.25) => fbGain.target;
    }
    
    fun void unset()
    { 
        0 => s.next;
    }
}

class BumpSounder extends Sounder
{
    Impulse i => LPF filter => Gain feedback;
    i => LPF filter2 => feedback;
    feedback => DelayA feedbackDelay => feedback;
    
    0.85 => feedbackDelay.gain;
    1::second => feedbackDelay.max;
    100::ms => feedbackDelay.delay;
    
    100 => filter.Q;
    273 => filter.freq;
    
    filter.Q()/5 => filter2.Q;
    filter.freq()*4 => filter2.freq;
    filter.gain()/10 => filter2.gain;
    
    Slewer fbGain;
    0.01 => fbGain.rate;
    0.9 => fbGain.target;
    fbGain.reset();
    
    spork ~ mod();
    
    fun UGen @ output() { return feedback; }
    
    fun void set(Blob b)
    {
        if(maybe)
        {
            Math.min(b.area/40000.0, 2)*100 => i.next;
        }
        0.9 + 0.09 * Math.pow((Math.min(b.width/100.0,1)), 0.25) => fbGain.target;
        //b.width/320.0 => 
    }
    
    fun void unset()
    {
    }
    
    fun void setFreq(float f)
    {
        f => filter.freq;
        filter.freq()*4 => filter2.freq;
    }
    
    fun void mod()
    {
        while(true)
        {
            fbGain.slew() => feedbackDelay.gain;
            10::ms => now;
        }
    }
}


Sounder sounders[3][3];

<<< "1" >>>;
for(0 => int i; i < sounders[0].cap(); i++)
{
    NoiseSounder s;
    s @=> sounders[0][i];
    55+i*2 => Std.mtof => s.setFreq;
    
    s.output() => dac;
} 

<<< "2" >>>;
for(0 => int i; i < sounders[1].cap(); i++)
{
    VoiceSounder s @=> sounders[1][i];
    62+i*2 => s.setNote;
    
    s.output() => dac;
} 

for(0 => int i; i < sounders[2].cap(); i++)
{
    BumpSounder s @=> sounders[2][i];
    62+i*2 => Std.mtof => s.setFreq;
    
    s.output() => dac;
} 

OscRecv recv;
6449 => recv.port;
recv.listen();

"/blobs i i" => string oscString;
for(0 => int i; i < 10; i++)
{
    oscString + " i i f f i i i i" => oscString;
}
recv.event(oscString) @=> OscEvent @ oe;

Blob b;

while( true )
{
    oe => now;
    
    while( oe.nextMsg() )
    {
        oe.getInt() => int type;
        oe.getInt() => int numBlobs;
        
        for(0 => int i; i < numBlobs && i < sounders[type].cap(); i++)
        {
            oe.getInt() => b.centerX;
            oe.getInt() => b.centerY;
            
            oe.getFloat() => b.area;
            oe.getFloat() => b.length;
            
            oe.getInt() => b.x;
            oe.getInt() => b.y;
            oe.getInt() => b.width;
            oe.getInt() => b.height;
            
            sounders[type][i].set(b);
        }
        
        for(numBlobs => int i; i < sounders[type].cap(); i++)
        {
            sounders[type][i].unset();
        }
    }
}

