
class VoiceSounder
{
    class FMVoice
    {
        SinOsc f1m => SinOsc f1c => Gain mix;
        SinOsc f2m => SinOsc f2c => mix;
        SinOsc f3m => SinOsc f3c => mix;
        
        2 => f1c.op => f2c.op => f3c.op;
        
        48 => Std.mtof => f1m.freq => f2m.freq => f3m.freq;
        1500 => f1m.gain => f2m.gain => f3m.gain;
        
        // the four-mants
        [ [ 740.0, 1108.0, 2489.0 ], // ah
        [ 530.0, 1864.0, 2637.0 ], // e
        [ 400.0,  800.0, 3250.0 ], // oo
        [ 431.0, 2434.0, 2913.0 ]  // i
        ] @=> float formants[][];
        
        
        formants[0][0] => f1c.freq;
        formants[0][1] => f2c.freq;
        formants[0][2] => f3c.freq;
        
        0.1 => mix.gain;
        
        fun UGen @ output() { return mix; }
        
        fun float freq(float f)
        {
            f => f1m.freq => f2m.freq => f3m.freq;
            return f;
        }
        
        fun float modGain(float mg)
        {
            mg => f1m.gain => f2m.gain => f3m.gain;
            return mg;
        }
    }
    
    Gain feedback => Gain master;
    feedback => DelayA feedbackDelay => feedback;
    
    0.7 => feedbackDelay.gain;
    1::second => feedbackDelay.max;
    100::ms => feedbackDelay.delay;
    
    FMVoice f[5];
    
    for(0 => int i; i < f.cap(); i++)
    {
        f[i].output() => feedback;
        48 + (i-f.cap()/2)*0.01 => Std.mtof => f[i].freq;
        1500 + (i-f.cap()/2)*100 => f[i].modGain;
    }
    
    SinOsc lfo2 => blackhole;
    1.0/(10) => lfo2.freq;
    spork ~ mod();
    //spork ~ { while(true) { (100+lfo3.last()*2)::ms => feedbackDelay.delay; 100::samp => now; } };
    
    fun UGen @ output() { return master; }
    
    fun float setNote(float n)
    {
        for(0 => int i; i < f.cap(); i++)
        {
            f[i].output() => feedback;
            n + (i-f.cap()/2)*0.001 => Std.mtof => f[i].freq;
            1500 + (i-f.cap()/2)*120 => f[i].modGain;
        }
        
        return n;
    }
    
    fun void mod()
    {
        while(true) { 0.5+lfo2.last()*0.3 => feedbackDelay.gain; 10::ms => now; }
    }
}

VoiceSounder vs;

48 => vs.setNote;
vs.output() => dac;

1::day => now;

