
#version 110

uniform sampler2D depthTex;
uniform sampler2D realtimeTex;
uniform int iteration;
uniform float threshold;
uniform float alphaFactor;
uniform mat4 realtimeMatrix;
uniform vec4 colorVector;

varying vec2 texture_coordinate;

void main()
{
    vec2 rtTexCoord = (vec4(texture_coordinate, 0, 0) * realtimeMatrix).xy;
    float depth = texture2D(depthTex, rtTexCoord).b;
    float rtDepth = texture2D(realtimeTex, texture_coordinate).b;
    //vec3 rgb = texture2D( rgbTex, texture_coordinate ).rgb;
    float alpha = 0.0;
    float red = 1.0;
    
    if(rtDepth < threshold && depth < threshold) discard;
    
    if(rtDepth < threshold)
    {
        alpha = pow(depth, 0.25)*0.5;
    }
    else
    {
        alpha = pow((rtDepth-threshold)/threshold, 8.0) + pow(depth, 4.0);
        red = alpha*alpha;
    }
    
    alpha *= alphaFactor;
    
    //gl_FragColor.rgb = (depth-threshold)/threshold*rgb;
	//gl_FragColor.rgb = rgb;
    gl_FragColor = vec4( red, red, red, alpha ) + colorVector;
}

