
#version 110

uniform sampler2D depthTex;
uniform sampler2D rgbTex;
uniform float threshold;
uniform float alphaFactor;
varying vec2 texture_coordinate;

void main()
{
    float depth = texture2D( depthTex, texture_coordinate ).b;
    //vec3 rgb = texture2D( rgbTex, texture_coordinate ).rgb;
    if( depth < threshold ) discard;
    
    float alpha = sqrt((depth-threshold)/(1.0-threshold)) * alphaFactor;
    //float alpha = depth;
    
    //gl_FragColor.rgb = (depth-threshold)/threshold*rgb;
	//gl_FragColor.rgb = rgb;
    gl_FragColor.rgb = vec3( alpha );
	gl_FragColor.a = 1.0;
}

