/*
 *  BlobDetector.h
 *  kinectBasic
 *
 *  Created by Spencer Salazar on 5/15/11.
 *  Copyright 2011 Spencer Salazar. All rights reserved.
 *
 */


#pragma once

#include "CircularBuffer.h"
#include "lo.h"
#include <vector>

using namespace std;

struct Blob
{
    int centerX, centerY;
    float area, length;
    int x, y, width, height;
};


class NetworkManager
{
public:
    NetworkManager(const char *host=NULL, const char *port=NULL);
    
    void sendBlobs(int type, vector<Blob> & blobs);
    
private:
    
    lo_address mAddress;
    int mCurrentBlobGroup;
    
};


class BlobDetector
{
public:
    
    BlobDetector();
    
    void start();
    void nextFrame(Surface frame);
    void cvThread();
    
private:
    boost::thread * mCvThread;
    CircularBuffer<Surface> * mCvBuffer;
    bool cvThreadDoExit;
    
    NetworkManager networkManager;
};


