/*
 *  VideoDelay.h
 *  kinectBasic
 *
 *  Created by Spencer Salazar on 5/14/11.
 *  Copyright 2011 Spencer Salazar. All rights reserved.
 *
 */

#include "CircularBuffer.h"

#pragma once

class VideoDelay
{
public:
    VideoDelay(int length=30);    
    VideoDelay(int length, Vec3f scale, Vec2f offset);
    
    void update(ImageSourceRef nextFrame);
    void draw(gl::GlslProg &shader);
    void setThreshold(float threshold);
    
private:
    
    Vec2f mOffset;
    Vec3f mScale;
    
    int mLength;
    CircularBuffer<ImageSourceRef> * mFrames;
    
    float alphaFactor;
    
    gl::Texture mTex;
    
    float mFrameSkip;
    float mThreshold;
};


